#include <stdio.h>
//NOM:ADJA MAME PENDA NDIAYE
//CODE PERMANENT:NDIA82360300


// Methode de division binaire par restauration des restes partiels
unsigned int division(unsigned int dividende, unsigned int diviseur, unsigned int *reste) {
    unsigned int quotient = 0;
    *reste = 0;/*le * devant le reste permet de differencier le pointeur et acceder a la valeur et permet de pas creer d'autres fonctions
    qui je trouve serai plus long et plus long*/

    /*Cette boucle permet de calculer le quotient et le reste de la division en parcourant 
    la dividende bit par bits en utiloisant les operations logiques et de decalages*/
    for (int i = 15; i >= 0; i--) {
        *reste = (*reste << 1) | ((dividende >> i) & 1);
        quotient = quotient << 1;

        if (*reste >= diviseur) {
            *reste -= diviseur;
            quotient |= 1;//on ajoute 1 a quotient en utilisiant l'operateur logique OR
        }
    }

    return quotient;
}
    //FONTION PRINCIPALE
int main() {
    int ndiv;
    printf("Entrez le nombre de divisions à effectuer : ");
    scanf("%d", &ndiv);

    // Ouverture du fichier
    FILE *fichier ;
    fichier = fopen("result.txt", "w");

    if (fichier == NULL) {
        fprintf(stderr, "Erreur lors de l'ouverture du fichier.\n");//stderr permet de rediriger des messages d'erreurs
        return 1;
                         }   

    for (int i = 1; i <= ndiv; i++) {
        unsigned int dividende, diviseur, reste; //declaration de variable entier non signées
        printf("Division %d : Entrez le dividende et le diviseur separés par '/' : ", i);
        scanf("%u/%u", &dividende, &diviseur);

     // VERIFICATION DES ERREURS POTENTIELS
        if (diviseur == 0) {
            fprintf(stderr, "Erreur : Le diviseur ne peut pas être zéro.\n");
            fclose(fichier);
            return 1;
        }

        if (dividende > 65535 || diviseur > 65535) {
            fprintf(stderr, "Erreur : Les valeurs doivent être comprises entre 0 et 65535.\n");
            fclose(fichier);
            return 1;
        }

    // Appel de la fonction de division
        unsigned int quotient = division(dividende, diviseur, &reste);

    // Écriture dans le fichier
        fprintf(fichier, "Division %d: %u / %u = %u reste %u\n", i, dividende, diviseur, quotient, reste);
    }

    // Fermeture du fichier
    fclose(fichier);

    printf("Les résultats sont dans le fichier 'resultats.txt'.\n");

    return 0;
}
