//________________________________________________________________________________________________________________________//
//       Auteur : Bineta Diongue, Youma Koumé, Anta Diack
//       Codes permanents : DIOB79280200 KOUY67310400  DIAA75260400
//       Description : Programme permettant permet de faire l'apprentissage du fonctionnement de la division de nombres
//                      binaires entiers positifs sur 16 bits.
//  _____________________________________________________________________________________________________________________//

#include <stdio.h>
#include <stdlib.h>


//Fonction pour la division binaire par restauration des restes partiels
  unsigned int division (unsigned int dividend, unsigned int divisor, unsigned int *remainder) {
  	//Initialise le reste a zero et le quotient a zero
  	unsigned int quotient = 0;
  	*remainder = 0;
  	int i;
  	//Iteration sur les bits du dividende 
  	 for ( i = 15; i>=0; i-- ) {
  	 	//Pour decaler le reste vers la gauche, ajout du bit suivant du dividende 
  	 	*remainder = ( *remainder << 1 ) | (( dividend >> i ) & 1 ) ;
  	 	quotient <<= 1;
  	 	//Test si le reste est suffisamment grand pour soustraire le diviseur 
  	 	if ( *remainder >= divisor ) {
  	 		*remainder -= divisor;
  	 		//Met a jour le bit correspondant du quotient
  	 		quotient |= 1;
		   }
	   } 
 return quotient;
  }

int main(int argc, char *argv[]) {
	
	//Ouvre le fichier en mode ecriture
	FILE *file = fopen("resultats.txt", "w");
	//Verifie si l'ouverture du fichier a reussi
	 if ( file == NULL ) {
	 	printf("Erreur lors de l'ouverture du fichier ! ! ! \n");
	 	 return 1;
	 }
	//Demande a l'utilisateur le nombre de divisions a effectuer
	int nbreDivisions;
	 printf("Entrez le nombre de divisions a effectuer : \t ");
	  scanf("%d",&nbreDivisions);
	  
	  //Variables pour stocker le resultat final
	    unsigned int finalQuotient = 0;
	    unsigned int finalRemainder = 0;
	   
	   int i;
	   //Iteration sur le nombre de divisions que l'utilisateur veut effectuer
	    for ( i = 1; i <= nbreDivisions; ++i ) {
	    	unsigned int dividend, divisor, remainder;
	    
	    //Boucle de saisie pour respecter les valeurs du dividende et du diviseur
	    do {
		
	    	//Demande les valeurs du dividende et du diviseur
	    	 printf("Division %d : Entrez le dividende ( 0 - 65535 ) et le diviseur ( 1 - 65535 ) separes par un espace : ",i);
	    	  scanf("%u %u",&dividend,&divisor);
	      if ( dividend < 0 || dividend > 65535 || divisor < 1 || divisor >65535) {
	      	printf("Les valeurs doivent respecter les contraintes... \n");
		  }
	     }
	     
	    while (dividend < 0 || dividend > 65535 || divisor < 1 || divisor > 65535 );
	    
	    	//Fait appel a la fonction de division 
	    	unsigned int quotient = division( dividend, divisor, &remainder);
	    	
	    	//Affiche les resultats a la console
	    	 printf("Division %d : %u / %u = %u reste %u \n",i,dividend,divisor,quotient,remainder);
	    	
	    	//Ecrit les resultats dans le fichier
	    	 fprintf(file, "Division %d : %u / %u  = %u  reste %u \n ",i,dividend,divisor,quotient,remainder);
	    	 
	    	 //Met a jour le resultat final a la console
	    	   finalQuotient += quotient;
	    	   finalRemainder += remainder;
	    	 
		}
		
	//Affiche le resultat final a la console
	 printf("RESULTAT FINAL : Quotient = %u \t \t Reste = %u \n",finalQuotient,finalRemainder);
	//Procede a la fermeture du fichier	 
	fclose(file);
	//Affiche le message indiquant l'enregistrement des resultats dans le fichier 
	printf("Les resultats ont ete enregistres dans le fichier 'resultats.txt'. \n");
	
	return 0;
}
