/*
  Programme réalisé par :
  - Rayane Dakech DAKR70260500
  - Mohamed Tazi TAZM76370200
  - Tameze Voufo Manuelle Tatiana TAMM78350000
  
  Groupe 01 du Mercredi de 15:30-18:30.
*/
#include <stdio.h>
// La fonction prend deux entiers non signés en entrée et retourne le résultat de la division a / b.
unsigned int division(unsigned int a, unsigned int b)
{
    // Décalage de b de 16 bits à gauche. Cela équivaut à multiplier b par 2^16.
    b = b << 16;
    // La boucle s'exécute 16 fois, correspondant à la taille d'un entier non signé (32 bits).
    for (int i = 0; i < 16; i++)
    {
        // Décalage de a de 1 bit à gauche. Cela équivaut à multiplier a par 2.
        a = a << 1;
        // Si a est plus grand ou égal à b après le décalage, cela signifie que l'on peut soustraire b de a.
        if (a >= b)
        {
            // Soustraction de b de a.
            a = a - b;
            // Ajout de 1 à a .
            a = a + 1;
        }
        // À la fin de la boucle "a" contient le reste de la division.
    }
    // La fonction retourne le reste de la division a % b.
    return a;
}
int main()
{
    // Déclaration d'un pointeur de fichier pour stocker les résultats des divisions
    FILE *Fichiertxt;
    unsigned int i /*Variable de boucle*/, Dividende /*Représente le dividende dans une opération de division*/, Diviseur /*Représente le diviseur dans une opération de division*/, Reste /*Stocke le reste d'une opération de division*/, quotient /*Stocke le quotient d'une opération de division*/, N /* Nombre total d'opérations de division spécifié par l'utilisateur*/;
    // Ouverture du fichier en écriture
    Fichiertxt = fopen("resultats.txt", "w");
    // Demander à l'utilisateur le nombre de divisions
    printf("Entrez le nombre de divisions : ");
    scanf("%i", &N);
    // Vérifier si le nombre de divisions est inférieur ou égal à zéro
    while (N <= 0)
    {
        // Afficher un message d'erreur
        printf("Le nombre de divisions doit être supérieur à zéro.\n");
        // Redemander à l'utilisateur le nombre de divisions
        printf("Rentrez le nombre de divisions : ");
        scanf("%i", &N);
    }
    // Effectuer les divisions
    for (i = 1; i <= N; i++)
    {
        // Déclaration d'une variable pour stocker une partie du quotient
        unsigned short c;
        // Demander à l'utilisateur le Dividendee et le diviseur
        printf("Division %i: Entrez le Dividendee et le diviseur (séparés par un espace) : ", i);
        scanf("%i %i", &Dividende, &Diviseur);
        // Vérifier les valeurs du dividende et du diviseur
        while (Dividende < 0 || Dividende > 65535 || Diviseur < 1 || Diviseur > 65535)
        {
            // Afficher un message d'erreur si les valeurs ne sont pas dans les plages autorisées
            printf("Les valeurs du dividende et du diviseur ne sont pas dans les plages autorisées.\n");
            // Redemander à l'utilisateur le Dividendee et le diviseur
            printf("Division %i: Rentrez le Dividende(entre 0 et 65535) et le diviseur (entre 1 et 65535),(séparés par un espace) : ", i);
            scanf("%i %i", &Dividende, &Diviseur);
        }
        // Effectuer la division
        quotient = division(Dividende, Diviseur);
        // Conversion de type,stocker les 16 bits moins significatifs du quotient dans la variable c
        c = (unsigned short)quotient;
        // Décalage de 16 bits vers la droite pour obtenir la partie restante du quotient
        quotient = quotient >> 16;
        // Écrire les résultats dans le fichier
        fprintf(Fichiertxt, "Division %d: %i / %i = %d reste %i\n", i, Dividende, Diviseur, c, quotient);
    }
    // Fermer le fichier
    fclose(Fichiertxt);
    return 0;
}