/* MENBRES DU GROUPE:
nom: Aichatou Cisse                code permanent:BASA66330300
nom: Boyom Matsi  Lyn Joyce        code permanent:BOYL82290500
nom: Tekamgueu Epome Tiana Daniele code permanent:TEKT73260300 */

// TP2.cpp : Ce fichier contient la fonction 'main'. L'exécution du programme commence et se termine à cet endroit.


#include <stdio.h>

#define MAX_DIVIDENDE 65535
#define MIN_DIVIDENDE 0
#define MAX_DIVISEUR 65535
#define MIN_DIVISEUR 1

/* la fonction division effectue la division binaire par restauration des restes partiels
  retourne le quotient(partie basse) de la division
 et reste pointe vers la variable de stockage du reste  */

unsigned short int division(unsigned short int dividende, unsigned short int diviseur, unsigned short int* reste) {
    unsigned short int quotient = 0;
    *reste = 0;

    while (dividende >= diviseur) {
        *reste = dividende - diviseur; // Calcul du reste
        dividende = *reste; // Nouveau dividende pour la prochaine itération
        quotient++;
    }

    return quotient;
}

int main()
{
    FILE* fptr;
    errno_t err;
    err = fopen_s(&fptr, "resultats.txt", "w");

    if (err != 0 || fptr == NULL) {
        printf("Erreur lors de l'ouverture du fichier.");
        return 1;
    }

    int num_divisions;
    printf("Entrez le nombre de divisions a effectuer : ");
    if (scanf_s("%d", &num_divisions) != 1) {
        printf("Erreur lors de la saisie du nombre de divisions.\n");
        fclose(fptr);
        return 1;
    }

    for (int i = 1; i <= num_divisions; i++) {
        unsigned short int dividende, diviseur, reste;
        printf("Division %d : Entrez le dividende (entre 0 et 65535) et le diviseur (entre 1 et 65535) : ", i);
        if (scanf_s("%hu %hu", &dividende, &diviseur) != 2) {
            printf("Erreur lors de la saisie des valeurs pour la division %d.\n", i);
            continue;
        }

        if (dividende < MIN_DIVIDENDE || dividende > MAX_DIVIDENDE || diviseur < MIN_DIVISEUR || diviseur > MAX_DIVISEUR) {
            printf("Les valeurs sont invalides pour la division.\n");
            continue;
        }

        unsigned short int quotient = division(dividende, diviseur, &reste);

        fprintf(fptr, "Division %d: %hu / %hu = %hu reste %hu\n", i, dividende, diviseur, quotient, reste);
    }

    fclose(fptr);
    printf("Les resultats sont disponibles dans le fichier resultats.txt\n");
    return 0;
}

// Exécuter le programme : Ctrl+F5 ou menu Déboguer > Exécuter sans débogage
// Déboguer le programme : F5 ou menu Déboguer > Démarrer le débogage

// Astuces pour bien démarrer : 
//   1. Utilisez la fenêtre Explorateur de solutions pour ajouter des fichiers et les gérer.
//   2. Utilisez la fenêtre Team Explorer pour vous connecter au contrôle de code source.
//   3. Utilisez la fenêtre Sortie pour voir la sortie de la génération et d'autres messages.
//   4. Utilisez la fenêtre Liste d'erreurs pour voir les erreurs.
//   5. Accédez à Projet > Ajouter un nouvel élément pour créer des fichiers de code, ou à Projet > Ajouter un élément existant pour ajouter des fichiers de code existants au projet.
//   6. Pour rouvrir ce projet plus tard, accédez à Fichier > Ouvrir > Projet et sélectionnez le fichier .sln.
