#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <stdbool.h>

/**SAMBA AISSATA KA,TCHINDOU MAGNOUDEWA BRIGITTE GROUPE 00 ET BOUPKESSI ESSOMANDA
ROMUALD GROUPE 01*/
/*
* Effectue la division binaire par restauration des restes partiels.
*
* @param dividend Le dividende (entier non sign de 16 bits)
* @param divisor Le diviseur (entier non sign de 16 bits)
* @param remainder Pointeur vers la variable o stocker le reste de la division (entier non sign de
16 bits)
*
* @return La partie basse de la valeur retourne est le quotient de la division.
* La partie haute de la valeur retourne est le reste de la division.
* Si le diviseur est zro, la fonction renvoie 0 et affiche une erreur.
*/
unsigned int division(unsigned int dividend, unsigned int divisor, unsigned int *remainder) {
 unsigned int quotient = 0;
 *remainder = 0;
int i;
if (divisor == 0) {
 printf("Erreur : Division par zro\n");
 return 0;
 }
 for (i = 15; i >= 0; i--) {
 *remainder = (*remainder << 1) | ((dividend >> i) & 1);
 quotient = quotient << 1;
 if (*remainder >= divisor) {
 *remainder = *remainder - divisor;
 quotient = quotient | 1;
 }
 }
 return quotient;
}
int main() {

 int numDivisions;
do {
 printf("Entrez le nombre de divisions (positif) : ");
 scanf("%d", &numDivisions);
 if (numDivisions <= 0) {
 printf("Erreur : Le nombre de divisions doit tre positif. Veuillez ressayer.\n");
 }
 } while (numDivisions <= 0);
 // Ouverture du fichier en mode criture
 FILE *fp = fopen("resultats.txt", "w");
int i;
 for (i = 1; i <= numDivisions; i++) {
 unsigned int dividend, divisor, remainder, quotient;
 // Saisie des valeurs du dividende et du diviseur
 do {
 printf("Division %d: Entrez le dividende (0-65535) et le diviseur (1-65535) (spars par un espace) : ", i);
 scanf("%u %u", &dividend, &divisor);
 if (dividend < 0 || dividend > 65535 || divisor <= 0 || divisor > 65535) {
 printf("Erreur : Valeurs incorrectes. Veuillez ressayer.\n");
 }
 } while (dividend < 0 || dividend > 65535 || divisor <= 0 || divisor > 65535);
 // Appel de la fonction de division
 quotient = division(dividend, divisor, &remainder);
 // Affichage des rsultats  l'cran
 printf("Division %d: %u / %u = %u reste %u\n", i, dividend, divisor, quotient, remainder);
 // criture des rsultats dans le fichier
 fprintf(fp, "Division %d: %u / %u = %u reste %u\n", i, dividend, divisor, quotient, remainder);
 }
 // Fermeture du fichier
 fclose(fp);
 return 0;
}
