//Devoir2.c         Author: Cheikh Tidiane Diakhaté
//                          Khady Loum
//                          Daour Top
//                          Cheikh Diakhaté

#include <stdio.h>
#include "tp2.h"

/*Cette fonction gère l'interaction avec l'utilisateur pour chaque division. 
    Elle demande les valeurs du dividende et du diviseur, appelle la fonction "division()" 
    pour effectuer la division, puis enregistre les résultats dans le fichier de sortie. 
    Elle effectue des validations pour s'assurer que les entrées de l'utilisateur sont valides.*/
    
void effectuerDivision(int nombreDivision, FILE *fichierSortie) {
    unsigned int dividende, diviseur, reste, quotient;
    printf("Division %d \n",nombreDivision);
    do
    {
        printf("Entrer le dividende (0-65535) : ");
        scanf("%u",&dividende);
    } while (dividende < 0 || dividende > 65535);
    do
    {
        printf("Entrer le diviseur (1-65535) : ");
        scanf("%u",&diviseur);
    } while (diviseur <= 0 || diviseur > 65535);

    quotient = division(dividende, diviseur, &reste);
    fprintf(fichierSortie, "Division %d: %u / %u = %u reste %u\n", nombreDivision, dividende, diviseur, quotient, reste);
    
}

/* La fonction principale du programme qui gère l'interaction avec l'utilisateur, 
    demande le nombre de divisions, ouvre le fichier de sortie, effectue les divisions 
    en appelant la fonction "effectuerDivision()" et enregistre les résultats dans le fichier.*/

int main() {
    FILE *fichierSortie;
    int numDivisions;

    // Demander le nombre de divisions à effectuer
    do{
        // En cas d'entrée invalide, reafficher le message
        printf("Entrez le nombre de divisions à effectuer : ");
    } while (scanf("%d", &numDivisions) != 1 || numDivisions <= 0);
    

    // Ouvrir le fichier en écriture
    fichierSortie = fopen("resultats.txt", "w");

    // Effectuer les divisions
    for (int i = 1; i <= numDivisions; i++) {
        effectuerDivision(i, fichierSortie);
    }

    // Fermer le fichier
    fclose(fichierSortie);

    printf("Les résultats ont été enregistrés dans le fichier 'resultats.txt'\n");

    return 0;
}
